"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Component_1 = __importDefault(require("../share/Component"));
var core_1 = __importDefault(require("highlight.js/lib/core"));
var javascript_1 = __importDefault(require("highlight.js/lib/languages/javascript"));
var xml_1 = __importDefault(require("highlight.js/lib/languages/xml"));
var css_1 = __importDefault(require("highlight.js/lib/languages/css"));
var last_1 = __importDefault(require("licia/last"));
var trim_1 = __importDefault(require("licia/trim"));
var isEmpty_1 = __importDefault(require("licia/isEmpty"));
var each_1 = __importDefault(require("licia/each"));
var startWith_1 = __importDefault(require("licia/startWith"));
var throttle_1 = __importDefault(require("licia/throttle"));
var copy_1 = __importDefault(require("licia/copy"));
core_1.default.configure({
    classPrefix: 'luna-syntax-highlighter-',
});
core_1.default.registerLanguage('javascript', javascript_1.default);
core_1.default.registerLanguage('css', css_1.default);
core_1.default.registerLanguage('xml', xml_1.default);
var SyntaxHighlighter = (function (_super) {
    __extends(SyntaxHighlighter, _super);
    function SyntaxHighlighter(container, options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this, container, { compName: 'syntax-highlighter' }, options) || this;
        _this.copy = function () {
            var c = _this.c;
            (0, copy_1.default)(_this.options.code);
            var $icon = _this.$copy.find(c('.icon'));
            $icon.addClass(c('icon-check')).rmClass(c('icon-copy'));
            setTimeout(function () {
                $icon.rmClass(c('icon-check')).addClass(c('icon-copy'));
            }, 1000);
        };
        _this.updateCopyPos = function () {
            var container = _this.container;
            _this.$copy.css({
                top: container.scrollTop + 5,
                right: -container.scrollLeft + 5,
            });
        };
        var code = '';
        var language = 'javascript';
        if (!options.code && container.tagName === 'PRE') {
            var $code = _this.$container.find('code');
            if (!(0, isEmpty_1.default)($code)) {
                code = $code.text();
                var className = $code.attr('class') || '';
                if ((0, startWith_1.default)(className, 'language-')) {
                    language = className.replace('language-', '');
                }
            }
        }
        _this.initOptions(options, {
            code: code,
            language: language,
            showLineNumbers: true,
            wrapLongLines: true,
        });
        _this.render = (0, throttle_1.default)(function () { return _this._render(); }, 16);
        _this.initTpl();
        _this.$code = _this.find('.code');
        _this.$copy = _this.find('.copy');
        if (_this.options.code) {
            _this.render();
        }
        _this.bindEvent();
        return _this;
    }
    SyntaxHighlighter.prototype.destroy = function () {
        this.$container.off('scroll', this.updateCopyPos);
        _super.prototype.destroy.call(this);
    };
    SyntaxHighlighter.prototype.initTpl = function () {
        this.$container.html(this.c("<code class=\"code\"></code><div class=\"copy\"><span class=\"icon icon-copy\"></span></div>"));
    };
    SyntaxHighlighter.prototype.bindEvent = function () {
        var _this = this;
        this.on('optionChange', function () { return _this.render(); });
        this.$container.on('scroll', this.updateCopyPos);
        this.$copy.on('click', this.copy);
    };
    SyntaxHighlighter.prototype._render = function () {
        var _a = this, c = _a.c, $copy = _a.$copy, $code = _a.$code;
        var _b = this.options, code = _b.code, language = _b.language, showLineNumbers = _b.showLineNumbers, wrapLongLines = _b.wrapLongLines;
        if (wrapLongLines) {
            $code.addClass(c('wrap-long-lines'));
        }
        else {
            $code.rmClass(c('wrap-long-lines'));
        }
        var highlightCode = core_1.default.highlight(code, { language: language }).value;
        if (!showLineNumbers) {
            $code.rmClass(c('line-numbers'));
            return this.$code.html(highlightCode);
        }
        $code.addClass(c('line-numbers'));
        var lines = getLines(highlightCode);
        if ((0, isEmpty_1.default)(lines)) {
            lines = ['&nbsp;'];
        }
        if (lines.length > 3) {
            $copy.show();
        }
        else {
            $copy.hide();
        }
        if (!(0, trim_1.default)((0, last_1.default)(lines))) {
            lines.pop();
        }
        var body = '';
        (0, each_1.default)(lines, function (line, idx) {
            body += "<div class=\"".concat(c('table-row'), "\"><div class=\"").concat(c('line-number'), "\">").concat(idx + 1, "</div><div class=\"").concat(c('line-code'), "\">").concat(line || ' ', "</div></div>");
        });
        $code.html("<div class=\"".concat(c('table'), "\">").concat(body, "</div>"));
        this.updateCopyPos();
    };
    SyntaxHighlighter.registerLanguage = function (name, fn) {
        core_1.default.registerLanguage(name, fn);
    };
    SyntaxHighlighter.getLanguage = function (name) {
        return core_1.default.getLanguage(name);
    };
    return SyntaxHighlighter;
}(Component_1.default));
exports.default = SyntaxHighlighter;
var regBreakLine = /\r\n|\r|\n/g;
function getLines(code) {
    if (code.length === 0) {
        return [];
    }
    return code.split(regBreakLine);
}
module.exports = SyntaxHighlighter;
module.exports.default = SyntaxHighlighter;
